VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4545
   ClientLeft      =   2010
   ClientTop       =   1860
   ClientWidth     =   5490
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4545
   ScaleWidth      =   5490
   Begin VB.TextBox txtStartDir 
      Height          =   285
      Left            =   1200
      TabIndex        =   0
      Text            =   "C:\"
      Top             =   0
      Width           =   2055
   End
   Begin VB.TextBox txtPattern 
      Height          =   285
      Left            =   1200
      TabIndex        =   1
      Text            =   "*.jpg"
      Top             =   360
      Width           =   2055
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   2
      Top             =   0
      Width           =   1215
   End
   Begin VB.ListBox lstFiles 
      Height          =   3765
      Left            =   0
      TabIndex        =   3
      Top             =   720
      Width           =   5415
   End
   Begin VB.Label Label1 
      Caption         =   "Start directory"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   0
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Pattern"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label lblNumFiles 
      Caption         =   "0 Files, 0 K"
      Height          =   255
      Left            =   3360
      TabIndex        =   4
      Top             =   480
      Width           =   2055
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1

Private Const MAX_PATH = 260
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long

Private Const ERROR_NO_MORE_FILES = 18&
Private Const INVALID_HANDLE_VALUE = -1
Private Const DDL_DIRECTORY = &H10

Private total_size As Double

' List all files below the directory that
' match the pattern.
Private Sub ListFiles(ByVal start_dir As String, ByVal pattern As String, ByVal lst As ListBox)
Const MAXDWORD = 2 ^ 32

Dim dir_names() As String
Dim num_dirs As Integer
Dim i As Integer
Dim fname As String
Dim attr As Integer
Dim search_handle As Long
Dim file_data As WIN32_FIND_DATA
Dim file_size As Double

    ' Get the matching files in this directory.

    ' Get the first file.
    search_handle = FindFirstFile( _
        start_dir & pattern, file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Get the rest of the files.
        Do
            fname = file_data.cFileName
            fname = Left$(fname, InStr(fname, Chr$(0)) - 1)
            file_size = (file_data.nFileSizeHigh * MAXDWORD) + file_data.nFileSizeLow
            If file_size > 0 Then
                lst.AddItem start_dir & fname & " (" & Format$(file_size) & ")"
                total_size = total_size + file_size
            Else
                lst.AddItem start_dir & fname
            End If

            ' Get the next file.
            If FindNextFile(search_handle, file_data) = 0 Then Exit Do
        Loop
        
        ' Close the file search hanlde.
        FindClose search_handle
    End If

    ' Get the list of subdirectories.
    search_handle = FindFirstFile( _
        start_dir & "*.*", file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Get the rest of the files.
        Do
            If file_data.dwFileAttributes And DDL_DIRECTORY Then
                fname = file_data.cFileName
                fname = Left$(fname, InStr(fname, Chr$(0)) - 1)
                If fname <> "." And fname <> ".." Then
                    num_dirs = num_dirs + 1
                    ReDim Preserve dir_names(1 To num_dirs)
                    dir_names(num_dirs) = fname
                End If
            End If
            
            ' Get the next file.
            If FindNextFile(search_handle, file_data) = 0 Then Exit Do
        Loop

        ' Close the file search handle.
        FindClose search_handle
    End If
    
    ' Search the subdirectories.
    For i = 1 To num_dirs
        ListFiles start_dir & dir_names(i) & "\", pattern, lst
    Next i
End Sub
Private Sub cmdSearch_Click()
Dim start_dir As String
Dim pattern As String
Dim file_list As String

    Screen.MousePointer = vbHourglass
    DoEvents

    total_size = 0
    start_dir = Trim$(txtStartDir.Text)
    If Right$(start_dir, 1) <> "\" Then _
        start_dir = start_dir & "\"
    pattern = Trim$(txtPattern.Text)
    ListFiles start_dir, pattern, lstFiles

    lblNumFiles.Caption = _
        Format$(lstFiles.ListCount) & " Files, " & _
        Format$(total_size / 1024#, "0.0") & " K"

    Screen.MousePointer = vbDefault
End Sub
Private Sub Form_Load()
    txtStartDir.SelStart = Len(txtStartDir.Text)
End Sub

Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - lstFiles.Top
    If hgt < 120 Then hgt = 120
    lstFiles.Move 0, lstFiles.Top, ScaleWidth, hgt
End Sub

' Open the double-clicked file.
Private Sub lstFiles_DblClick()
Dim file_name As String
Dim pos As Integer

    ' Remove the file's size.
    file_name = lstFiles.Text
    pos = InStrRev(file_name, " (")
    If pos > 0 Then file_name = Left$(file_name, pos - 1)

    ShellExecute Me.hwnd, "open", file_name, _
        vbNullString, vbNullString, SW_SHOWNORMAL
End Sub
